Const
     mpu_base = $330;
     control = mpu_base + 1;
Var
   tmp : Byte;
   a,i : Word;
   f : File;
   Buf : Array [1..$4000] of Word;
   LinPage : Word;

Procedure PutBlock(page,addr : word);
Begin
     Port[control] := $1;
     Port[mpu_base] := addr and $ff;
     Port[mpu_base] := (addr shr 8) and $ff;
     Port[mpu_base] := page and $ff;
     Port[mpu_base] := (page shr 8) and $ff;

     Port[mpu_base] := $00;
     Port[mpu_base] := $40;
     i := 0;
     repeat
           tmp := Port[mpu_base];
           Inc(i);
     until (tmp = $AC) or (i > 32000);
     If i > 32000 then
         WriteLn('ERROR get ack!')
     else
         WriteLn('write_mem ack = ',tmp);

     For i := 1 to $4000 do
         Begin
              PortW[mpu_base+2] := $5a5a;
         End;
End;

Procedure GetBlock(page,addr : word);
Begin
     Port[control] := $2;
     Port[mpu_base] := addr and $ff;
     Port[mpu_base] := (addr shr 8) and $ff;
     Port[mpu_base] := page and $ff;
     Port[mpu_base] := (page shr 8) and $ff;

     Port[mpu_base] := $00;
     Port[mpu_base] := $40;

     i := 0;
     repeat
           tmp := Port[mpu_base];
           Inc(i);
     until (tmp = $AC) or (i > 32000);
     If i > 32000 then
         WriteLn('ERROR get ack!')
     else
         WriteLn('read_mem ack = ',tmp);

     For i := 1 to $4000 do
         Begin
              Buf[i] := PortW[mpu_base+2];
         End;
End;

Begin
     a := Port[control];
     Port[control] := $3f;
     WriteLn('switch to UART ack: ',Port[mpu_base]);

     Assign(F,'dump');
     Rewrite(F,1);

     LinPage := 1;
     While LinPage < (2*1024*1024)/65536 do
           begin
                PutBlock(LinPage,0);
                PutBlock(LinPage,$4000);
                Inc(LinPage);
           end;

{     While LinPage < (2*1024*1024)/65536 do
           begin
                GetBlock(LinPage,0);
                GetBlock(LinPage,$4000);
                Inc(LinPage);
           end;
}
     {save}
     LinPage := 0;
     While LinPage < (2*1024*1024)/65536 do
           begin
                GetBlock(LinPage,0);
                {WriteLn('page = ',LinPage,'  addr = 0');}
                BlockWrite(F,Buf,SizeOf(Buf));
                GetBlock(LinPage,$4000);
                {WriteLn('page = ',LinPage,'  addr = $4000');}
                BlockWrite(F,Buf,SizeOf(Buf));
                Inc(LinPage);
           end;

     Close(F);
End.